package laboratoire4;

import java.util.Stack;

public class MovingPushed extends Pushed implements MovingPawn {
    private final Stack<PawnMovement> previousMoves = new Stack<>();
    private int moveCount = 0;

    public MovingPushed(Player player, int row, int col) {
        super(player, row, col);
    }

    @Override
    public void move(PawnMovement movement) {
        super.move(movement);
        previousMoves.push(movement);
        moveCount++;
    }

    @Override
    public void revertMove() {
        PawnMovement move = previousMoves.pop();
        setRow(row - getDirection());
        setCol(col - move.getMove());
        moveCount--;
    }

    @Override
    public int getMoveCount() {
        return moveCount;
    }
}
